Package org.optaplanner.core.impl.localsearch.decider.acceptor.stepcountinghillclimbing

## Class StepCountingHillClimbingAcceptor<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter<Solution_>
  - - org.optaplanner.core.impl.localsearch.event.LocalSearchPhaseLifecycleListenerAdapter<Solution_>
    - - org.optaplanner.core.impl.localsearch.decider.acceptor.AbstractAcceptor<Solution_>
      - - org.optaplanner.core.impl.localsearch.decider.acceptor.stepcountinghillclimbing.StepCountingHillClimbingAcceptor<Solution_>

- All Implemented Interfaces:
    `EventListener`, `Acceptor<Solution_>`, `LocalSearchPhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`

      public class StepCountingHillClimbingAcceptor<Solution_>
      extends AbstractAcceptor<Solution_>

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected int` | `count` |
    `protected int` | `stepCountingHillClimbingSize` |
    `protected StepCountingHillClimbingType` | `stepCountingHillClimbingType` |
    `protected Score` | `thresholdScore` |

    - ### Fields inherited from class org.optaplanner.core.impl.localsearch.decider.acceptor.AbstractAcceptor

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `StepCountingHillClimbingAcceptor​(int stepCountingHillClimbingSize, StepCountingHillClimbingType stepCountingHillClimbingType)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `isAccepted​(LocalSearchMoveScope<Solution_> moveScope)` |
    `void` | `phaseEnded​(LocalSearchPhaseScope<Solution_> phaseScope)` |
    `void` | `phaseStarted​(LocalSearchPhaseScope<Solution_> phaseScope)` |
    `void` | `stepEnded​(LocalSearchStepScope<Solution_> stepScope)` |

    - ### Methods inherited from class org.optaplanner.core.impl.localsearch.event.LocalSearchPhaseLifecycleListenerAdapter

      `stepStarted`

    - ### Methods inherited from class org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter

      `solvingEnded, solvingStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.localsearch.event.LocalSearchPhaseLifecycleListener

      `stepStarted`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener

      `solvingEnded, solvingStarted`

- - ### Field Detail

    - #### stepCountingHillClimbingSize

          protected int stepCountingHillClimbingSize

    - #### stepCountingHillClimbingType

          protected StepCountingHillClimbingType stepCountingHillClimbingType

    - #### thresholdScore

          protected Score thresholdScore

    - #### count

          protected int count

  - ### Constructor Detail

    - #### StepCountingHillClimbingAcceptor

          public StepCountingHillClimbingAcceptor​(int stepCountingHillClimbingSize,
                                                  StepCountingHillClimbingType stepCountingHillClimbingType)

  - ### Method Detail

    - #### phaseStarted

          public void phaseStarted​(LocalSearchPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseStarted` in interface `LocalSearchPhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseStarted` in class `LocalSearchPhaseLifecycleListenerAdapter<Solution_>`

    - #### isAccepted

          public boolean isAccepted​(LocalSearchMoveScope<Solution_> moveScope)

      Parameters:
        `moveScope` - not null
      Returns:
        true if accepted

    - #### stepEnded

          public void stepEnded​(LocalSearchStepScope<Solution_> stepScope)

      Specified by:
        `stepEnded` in interface `LocalSearchPhaseLifecycleListener<Solution_>`
      Overrides:
        `stepEnded` in class `LocalSearchPhaseLifecycleListenerAdapter<Solution_>`

    - #### phaseEnded

          public void phaseEnded​(LocalSearchPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseEnded` in interface `LocalSearchPhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseEnded` in class `LocalSearchPhaseLifecycleListenerAdapter<Solution_>`